#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <errno.h>

struct msgbuf1 {
	long mtype;
	char mtext[8192];
} sndbuf, rcvbuf, *msgp;


main()
{
	int i, c, flag, flags, choice;
	int rtrn, msqid, msgsz, msgflg;
	long mtype, msgtyp;
	struct msqid_ds msqid_ds, *buf;
	buf = &msqid_ds;

	printf("Enter the msqid: ");
	scanf("%i", &msqid);

	printf("\n1 = send, 2 = receive\n");
	printf("Operation: ");
	scanf("%i", &choice);

	if (choice == 1) {
		msgp = &sndbuf;

		printf("Enter integer message type: ");
		scanf("%i", &msgtyp);
		msgp->mtype = msgtyp;

		printf("Enter the message (end with ^D):\n");
		for (i=0; i < sizeof(sndbuf.mtext) && ((c = getchar()) != EOF); i++)
			sndbuf.mtext[i] = c;

		msgsz = i;

		printf("\nMessage:\n");
		for (i=0; i< msgsz; i++)
			putchar(sndbuf.mtext[i]);

		printf("\nEnter 1 for IPC_NOWAIT: ");
		scanf("%i", &flag);
		if (flag == 1)
			msgflg = IPC_NOWAIT;
		else
			msgflg = 0;

		rtrn = msgsnd(msqid, (struct msgbuf *)msgp, msgsz, msgflg);
		if (rtrn == -1)
			perror("msgsnd");
		else {
			printf("\nmsgsnd returned %d\n", rtrn);

			if (msgctl(msqid, IPC_STAT, buf) == -1)
				perror("msgctl");
			else
				printf("qnum = %d, lspid = %d, stime = %d\n",
					buf->msg_qnum, buf->msg_lspid,
					buf->msg_stime);
		}
	}

	if (choice == 2) {
		msgp = &rcvbuf;

		printf("Enter integer message type: ");
		scanf("%i", &msgtyp);
		msgp->mtype = msgtyp;

		printf("\n0 = no flags, 1 = MSG_NOERROR, 2 = IPC_NOWAIT, 3 = NOERROR+NOWAIT\n");
		printf("Flags: ");
		scanf("%i", &flags);

		switch (flags) {
			case 0:
				msgflg = 0;
				break;
			case 1:
				msgflg = MSG_NOERROR;
				break;
			case 2:
				msgflg = IPC_NOWAIT;
				break;
			case 3:
				msgflg = MSG_NOERROR | IPC_NOWAIT;
				break;
		}

		printf("\nNumber of bytes to receive: ");
		scanf("%i", &msgsz);

		rtrn = msgrcv(msqid, (struct msgbuf *)msgp, msgsz, msgtyp, msgflg);
		if (rtrn == -1)
			perror("msgrcv");
		else {
			printf("\nBytes received = %d\n", rtrn);
			printf("Message:\n");
			for (i=0; i<rtrn; i++)
				putchar(rcvbuf.mtext[i]);
			putchar('\n');

			if (msgctl(msqid, IPC_STAT, buf) == -1)
				perror("msgctl");
			else 
				printf("qnum = %d, lrpid = %d, rtime = %d\n",
					buf->msg_qnum, buf->msg_lrpid,
					buf->msg_rtime);
		}
	}
}
