#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <errno.h>


main()
{
	struct semid_ds semid_ds;
	int c, i, length;
	int uid, gid, mode;
	int rtrn, semid, semnum, cmd, choice;

	union semun {
		int val;
		struct semid_ds *buf;
		unsigned short array[25];
	} arg;

	arg.buf = &semid_ds;

	printf("\nEnter the semid: ");
	scanf("%i", &semid);

	printf("\n1 = GETVAL\n2 = SETVAL\n3 = GETPID\n4 = GETNCNT\n");
	printf("5 = GETZCNT\n6 = GETALL\n7 = SETALL\n8 = IPC_STAT\n");
	printf("9 = IPC_SET\n10 = IPC_RMID\n");
	printf("Operation: ");
	scanf("%d", &cmd);

	switch (cmd) {
		case 1:
			printf("\nEnter the semnum: ");
			scanf("%d", &semnum);
			rtrn = semctl(semid, semnum, GETVAL, 0);
			printf("semval = %d\n", rtrn);
			break;
		case 2:
			printf("\nEnter the semnum: ");
			scanf("%d", &semnum);
			printf("Enter the value: ");
			scanf("%i", &arg.val);
			rtrn = semctl(semid, semnum, SETVAL, arg.val);
			break;
		case 3:
			rtrn = semctl(semid, 0, GETPID, 0);
			printf("pid = %d\n", rtrn);
			break;
		case 4:
			printf("\nEnter the semnum: ");
			scanf("%d", &semnum);
			rtrn = semctl(semid, semnum, GETNCNT, 0);
			printf("semncnt = %d\n", rtrn);
			break;
		case 5:
			printf("\nEnter the semnum: ");
			scanf("%d", &semnum);
			rtrn = semctl(semid, semnum, GETZCNT, 0);
			printf("semzcnt = %d\n", rtrn);
			break;
		case 6:
			arg.buf = &semid_ds;
			rtrn = semctl(semid, 0, IPC_STAT, arg.buf);
			if (rtrn == -1)
				break;
			length = arg.buf->sem_nsems;
			rtrn = semctl(semid, 0, GETALL, arg.array);
			for (i=0; i<length; i++)
				printf("%d ", arg.array[i]);
			printf("\n");
			break;
		case 7:
			arg.buf = &semid_ds;
			rtrn = semctl(semid, 0, IPC_STAT, arg.buf);
			if (rtrn == -1)
				break;
			length = arg.buf->sem_nsems;
			printf("Length = %d\n", length);
			printf("Enter each value:\n");
			for (i=0; i<length; i++) {
				printf("%d: ", i);
				scanf("%d", &c);
				arg.array[i] = c;
			}
			rtrn = semctl(semid, 0, SETALL, arg.array);
			break;
		case 8:
			arg.buf = &semid_ds;
			rtrn = semctl(semid, 0, IPC_STAT, arg.buf);
			printf("User = %d, group = %d, perm =0%o, nsem = %d\n",
				arg.buf->sem_perm.uid, arg.buf->sem_perm.gid,
				arg.buf->sem_perm.mode, arg.buf->sem_nsems);
			printf("otime = %d, ctime = %d\n",
				arg.buf->sem_otime, arg.buf->sem_ctime);
			break;
		case 9:
			arg.buf = &semid_ds;
			rtrn = semctl(semid, 0, IPC_STAT, arg.buf);
			if (rtrn == -1)
				break;
			printf("1 = user, 2 = group, 3 = mode\n");
			printf("Change: ");
			scanf("%d", &choice);
			switch (choice) {
				case 1:
					printf("Enter user id: ");
					scanf("%i", &uid);
					arg.buf->sem_perm.uid = uid;
					break;
				case 2:
					printf("Enter group id: ");
					scanf("%i", &gid);
					arg.buf->sem_perm.gid = gid;
					break;
				case 3:
					printf("Enter perms: ");
					scanf("%i", &mode);
					arg.buf->sem_perm.mode = mode;
					break;
			}
			rtrn = semctl(semid, 0, IPC_SET, arg.buf);
			break;
		case 10:
			rtrn = semctl(semid, 0, IPC_RMID, 0);
	}

	if (rtrn == -1)
		perror("semctl");

	exit(0);
}
