#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>


main()
{
	int uid, gid, mode;
	int rtrn, shmid, command, choice;
	struct shmid_ds shmid_ds, *buf;

	buf = &shmid_ds;

	printf("\nEnter the shmid: ");
	scanf("%i", &shmid);

	printf("\n1 = IPC_STAT\n2 = IPC_SET\n3 = IPC_RMID\n");
	printf("4 = SHM_LOCK\n5 = SHM_UNLOCK\n");
	printf("Operation: ");
	scanf("%i", &command);

	switch (command) {
		case 1:
			rtrn = shmctl(shmid, IPC_STAT, buf);
			printf("User = %d, group = %d, cuid = %d, guid = %d\n",
				buf->shm_perm.uid, buf->shm_perm.gid,
				buf->shm_perm.cuid, buf->shm_perm.cgid);
			printf("perms = 0%o\n",
				buf->shm_perm.mode);
			printf("seq = %d\n", buf->shm_perm.seq);
			printf("key = 0x%x\n", buf->shm_perm.key);
			printf("seq size = %d\n", buf->shm_segsz);
			printf("lpid = %d, cpid = %d\n", buf->shm_lpid, buf->shm_cpid);
			printf("nattach = %d\n", buf->shm_nattch);
#ifndef __linux__
			printf("cnattach = %d\n", buf->shm_cnattch);
#endif
			printf("atime = %d, dtime = %d, ctime = %d\n",
				buf->shm_atime, buf->shm_dtime, buf->shm_ctime);
			break;
		case 2:
			rtrn = shmctl(shmid, IPC_STAT, buf);
			if (rtrn == -1)
				break;
			printf("1 = uid, 2 = gid, 3 = mode\n");
			printf("Change: ");
			scanf("%d", &choice);
			switch (choice) {
				case 1:
					printf("User id: ");
					scanf("%i", &uid);
					buf->shm_perm.uid = uid;
					break;
				case 2:
					printf("Group id: ");
					scanf("%i", &gid);
					buf->shm_perm.gid = gid;
					break;
				case 3:
					printf("perms: ");
					scanf("%i", &mode);
					buf->shm_perm.mode = mode;
					break;
			}

			rtrn = shmctl(shmid, IPC_SET, buf);
			break;
		case 3:
			rtrn = shmctl(shmid, IPC_RMID, NULL);
			break;
		case 4:
			rtrn = shmctl(shmid, SHM_LOCK, NULL);
			break;
		case 5:
			rtrn = shmctl(shmid, SHM_UNLOCK, NULL);
			break;
	}

	if (rtrn == -1)
		perror("shmctl");

	exit(0);
}
