#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stream.h>
#include <sys/tihdr.h>
#include <sys/timod.h>
#include <fcntl.h>
#include <stropts.h>
#include <tiuser.h>
#include <errno.h>
#include <netinet/in.h>


main(int argc, char *argv[])
{
	int d, i, flags;
	char c;
	struct strbuf ctl, dat;
	char buf[4096];

	d = open("/dev/X0R", O_RDWR);
	printf("open /dev/X0R -> %d\n", d);

	c = 3;
	i = write(d, &c, 1);
	printf("write 1 byte -> %d\n", i);

	ctl.maxlen = sizeof(buf);
	ctl.buf = &buf;
	dat.maxlen = -1;
	dat.len = dat.buf = 0;
	flags = 0;
	i = getmsg(d, &ctl, &dat, &flags);
	printf("getmsg: i = %d, len = %d, errno = %d\n", i, ctl.len, errno);
	if (ctl.len > 0) for (i=0; i<ctl.len && i<64; i+=4)
		printf("ctl: 0x%08lx\n", *(unsigned long *)(ctl.buf+i));
}
