#include <sys/tiuser.h>
#include <errno.h>
#include <fcntl.h>


extern int t_errno;


main(argc, argv)
	int argc;
	char *argv[];
{
	struct t_info info;
	int d;
	struct t_call *buf;

	d = t_open(argv[1], O_RDWR, &info);
	printf("t_open returned %d, t_errno = %d, errno = %d\n",
		d, t_errno, errno);

	printf("addr: %d\n", info.addr);
	printf("options: %d\n", info.options);
	printf("tsdu: %d\n", info.tsdu);
	printf("etsdu: %d\n", info.etsdu);
	printf("connect: %d\n", info.connect);
	printf("discon: %d\n", info.discon);
	printf("servtype: %d\n", info.servtype);

	buf = t_alloc(d, T_CALL, T_ALL);
	printf("t_alloc returned 0x%08lx, t_errno = %d, errno = %d\n",
		buf, t_errno, errno);

	printf("t_call addr: maxlen=%d, len=%d, buf=0x%08lx\n",
		buf->addr.maxlen, buf->addr.len, buf->addr.buf);
	printf("t_call opt: maxlen=%d, len=%d, buf=0x%08lx\n",
		buf->opt.maxlen, buf->opt.len, buf->opt.buf);
	printf("t_call udata: maxlen=%d, len=%d, buf=0x%08lx\n",
		buf->udata.maxlen, buf->udata.len, buf->udata.buf);

	exit(0);
}
