#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>

main(argc, argv)
	int argc;
	char *argv[];
{
	struct stat st;

	if (stat(argv[1], &st) < 0) {
		perror(argv[1]);
		exit(1);
	}

	printf("sizeof(struct stat): %d\n", sizeof(struct stat));
	printf("st_dev: 0x%x\n", st.st_dev);
	printf("st_ino: %d\n", st.st_ino);
	printf("st_mode: 0x%x\n", st.st_mode);
	printf("st_nlink: %d\n", st.st_nlink);
	printf("st_uid: %d\n", st.st_uid);
	printf("st_gid: %d\n", st.st_gid);
	printf("st_rdev: 0x%x\n", st.st_rdev);
	printf("st_size: %d\n", st.st_size);
	printf("st_atime: %d\n", st.st_atime);
	printf("st_mtime: %d\n", st.st_mtime);
	printf("st_ctime: %d\n", st.st_ctime);
	printf("st_blksize: %d\n", st.st_blksize);
	printf("st_blocks: %d\n", st.st_blocks);
	printf("st_fstype: \"%s\"\n", st.st_fstype);
	printf("st_sco_flags: %d\n", st.st_sco_flags);
	exit(0);
}
