#include <errno.h>
#include <signal.h>
#include <stdio.h>

#include "ldt.h"
#include "syscall.h"
#include "lcall7.h"

#ifdef DEBUG
# include "debug.h"
#endif


int
emu_ftime(struct sigcontext_struct *sc)
{
	return lcall7(sc->eax & 0xffff,
		ldt[sc->ds>>3].base + (sc->ebx & 0xffff));
}


int
emu_time(struct sigcontext_struct *sc)
{
	sc->ebx = (time(&sc->eax) >> 16);
	return sc->eax;
}
